# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_dhcppolicyoptionvalue`](#dsc_dhcppolicyoptionvalue): The DSC DhcpPolicyOptionValue resource type. Automatically generated from version 3.0.0
* [`dsc_dhcpreservedipoptionvalue`](#dsc_dhcpreservedipoptionvalue): The DSC DhcpReservedIPOptionValue resource type. Automatically generated from version 3.0.0
* [`dsc_dhcpscopeoptionvalue`](#dsc_dhcpscopeoptionvalue): The DSC DhcpScopeOptionValue resource type. Automatically generated from version 3.0.0
* [`dsc_dhcpserverbinding`](#dsc_dhcpserverbinding): The DSC DhcpServerBinding resource type. Automatically generated from version 3.0.0
* [`dsc_dhcpserverexclusionrange`](#dsc_dhcpserverexclusionrange): The DSC DhcpServerExclusionRange resource type. Automatically generated from version 3.0.0
* [`dsc_dhcpserveroptionvalue`](#dsc_dhcpserveroptionvalue): The DSC DhcpServerOptionValue resource type. Automatically generated from version 3.0.0
* [`dsc_xdhcpserverauthorization`](#dsc_xdhcpserverauthorization): The DSC xDhcpServerAuthorization resource type. Automatically generated from version 3.0.0
* [`dsc_xdhcpserverclass`](#dsc_xdhcpserverclass): The DSC xDhcpServerClass resource type. Automatically generated from version 3.0.0
* [`dsc_xdhcpserveroptiondefinition`](#dsc_xdhcpserveroptiondefinition): The DSC xDhcpServerOptionDefinition resource type. Automatically generated from version 3.0.0
* [`dsc_xdhcpserverreservation`](#dsc_xdhcpserverreservation): The DSC xDhcpServerReservation resource type. Automatically generated from version 3.0.0
* [`dsc_xdhcpserverscope`](#dsc_xdhcpserverscope): The DSC xDhcpServerScope resource type. Automatically generated from version 3.0.0

## Resource types

### <a name="dsc_dhcppolicyoptionvalue"></a>`dsc_dhcppolicyoptionvalue`

The DSC DhcpPolicyOptionValue resource type.
Automatically generated from version 3.0.0

#### Properties

The following properties are available in the `dsc_dhcppolicyoptionvalue` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether the DHCP option should exist.

##### `dsc_scopeid`

Data type: `Optional[String]`

Scope ID to get policy values from. Do not use it to get an option from server level.

##### `dsc_value`

Data type: `Optional[Array[String]]`

Option data value. Could be an array of string for a multivalued option.

#### Parameters

The following parameters are available in the `dsc_dhcppolicyoptionvalue` type.

* [`dsc_addressfamily`](#dsc_addressfamily)
* [`dsc_optionid`](#dsc_optionid)
* [`dsc_policyname`](#dsc_policyname)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_vendorclass`](#dsc_vendorclass)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_addressfamily"></a>`dsc_addressfamily`

namevar

Data type: `Enum['IPv4']`

Address family. Currently needs to be IPv4.

##### <a name="dsc_optionid"></a>`dsc_optionid`

namevar

Data type: `Integer[0, 4294967295]`

Option ID, specify an integer between 1 and 255.

##### <a name="dsc_policyname"></a>`dsc_policyname`

namevar

Data type: `String`

Policy Name.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_vendorclass"></a>`dsc_vendorclass`

namevar

Data type: `String`

Vendor class. Use an empty string for default vendor class.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_dhcpreservedipoptionvalue"></a>`dsc_dhcpreservedipoptionvalue`

The DSC DhcpReservedIPOptionValue resource type.
Automatically generated from version 3.0.0

#### Properties

The following properties are available in the `dsc_dhcpreservedipoptionvalue` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether the DHCP option should exist.

##### `dsc_value`

Data type: `Optional[Array[String]]`

Option data value. Could be an array of string for a multivalued option.

#### Parameters

The following parameters are available in the `dsc_dhcpreservedipoptionvalue` type.

* [`dsc_addressfamily`](#dsc_addressfamily)
* [`dsc_optionid`](#dsc_optionid)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_reservedip`](#dsc_reservedip)
* [`dsc_userclass`](#dsc_userclass)
* [`dsc_vendorclass`](#dsc_vendorclass)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_addressfamily"></a>`dsc_addressfamily`

namevar

Data type: `Enum['IPv4']`

Address family. Currently needs to be IPv4.

##### <a name="dsc_optionid"></a>`dsc_optionid`

namevar

Data type: `Integer[0, 4294967295]`

Option ID, specify an integer between 1 and 255.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_reservedip"></a>`dsc_reservedip`

namevar

Data type: `String`

Reserved IP to set the option value.

##### <a name="dsc_userclass"></a>`dsc_userclass`

namevar

Data type: `String`

User class. Use an empty string for default user class.

##### <a name="dsc_vendorclass"></a>`dsc_vendorclass`

namevar

Data type: `String`

Vendor class. Use an empty string for default vendor class.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_dhcpscopeoptionvalue"></a>`dsc_dhcpscopeoptionvalue`

The DSC DhcpScopeOptionValue resource type.
Automatically generated from version 3.0.0

#### Properties

The following properties are available in the `dsc_dhcpscopeoptionvalue` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether the DHCP option should exist.

##### `dsc_value`

Data type: `Optional[Array[String]]`

Option data value.

#### Parameters

The following parameters are available in the `dsc_dhcpscopeoptionvalue` type.

* [`dsc_addressfamily`](#dsc_addressfamily)
* [`dsc_optionid`](#dsc_optionid)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_scopeid`](#dsc_scopeid)
* [`dsc_userclass`](#dsc_userclass)
* [`dsc_vendorclass`](#dsc_vendorclass)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_addressfamily"></a>`dsc_addressfamily`

namevar

Data type: `Enum['IPv4']`

Address family. Currently needs to be IPv4.

##### <a name="dsc_optionid"></a>`dsc_optionid`

namevar

Data type: `Integer[0, 4294967295]`

Option ID, specify an integer between 1 and 255.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_scopeid"></a>`dsc_scopeid`

namevar

Data type: `String`

Scope ID to set the option.

##### <a name="dsc_userclass"></a>`dsc_userclass`

namevar

Data type: `String`

User class. Use an empty string for default user class.

##### <a name="dsc_vendorclass"></a>`dsc_vendorclass`

namevar

Data type: `String`

Vendor class. Use an empty string for default vendor class.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_dhcpserverbinding"></a>`dsc_dhcpserverbinding`

The DSC DhcpServerBinding resource type.
Automatically generated from version 3.0.0

#### Properties

The following properties are available in the `dsc_dhcpserverbinding` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies if the interface alias should be set or removed. Defaults to 'Present'.

#### Parameters

The following parameters are available in the `dsc_dhcpserverbinding` type.

* [`dsc_interfacealias`](#dsc_interfacealias)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_interfacealias"></a>`dsc_interfacealias`

namevar

Data type: `String`

Specifies the alias name for the network interface to manage.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_dhcpserverexclusionrange"></a>`dsc_dhcpserverexclusionrange`

The DSC DhcpServerExclusionRange resource type.
Automatically generated from version 3.0.0

#### Properties

The following properties are available in the `dsc_dhcpserverexclusionrange` type.

##### `dsc_addressfamily`

Data type: `Optional[Enum['IPv4']]`

Address family type

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether the exclusion range should be set or removed

##### `dsc_scopeid`

Data type: `String`

Specifies the identifier (ID) of the IPv4 scope from which the IP addresses are being excluded

#### Parameters

The following parameters are available in the `dsc_dhcpserverexclusionrange` type.

* [`dsc_ipendrange`](#dsc_ipendrange)
* [`dsc_ipstartrange`](#dsc_ipstartrange)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_ipendrange"></a>`dsc_ipendrange`

namevar

Data type: `String`

The end IP address of the range being excluded

##### <a name="dsc_ipstartrange"></a>`dsc_ipstartrange`

namevar

Data type: `String`

Specifies the starting IP address of the range being excluded

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_dhcpserveroptionvalue"></a>`dsc_dhcpserveroptionvalue`

The DSC DhcpServerOptionValue resource type.
Automatically generated from version 3.0.0

#### Properties

The following properties are available in the `dsc_dhcpserveroptionvalue` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether the DHCP option should exist.

##### `dsc_value`

Data type: `Optional[Array[String]]`

Option data value. Could be an array of string for a multivalued option.

#### Parameters

The following parameters are available in the `dsc_dhcpserveroptionvalue` type.

* [`dsc_addressfamily`](#dsc_addressfamily)
* [`dsc_optionid`](#dsc_optionid)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_userclass`](#dsc_userclass)
* [`dsc_vendorclass`](#dsc_vendorclass)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_addressfamily"></a>`dsc_addressfamily`

namevar

Data type: `Enum['IPv4']`

Address family. Currently needs to be IPv4.

##### <a name="dsc_optionid"></a>`dsc_optionid`

namevar

Data type: `Integer[0, 4294967295]`

Option ID, specify an integer between 1 and 255.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_userclass"></a>`dsc_userclass`

namevar

Data type: `String`

User class. Use an empty string for default user class.

##### <a name="dsc_vendorclass"></a>`dsc_vendorclass`

namevar

Data type: `String`

Vendor class. Use an empty string for default vendor class.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xdhcpserverauthorization"></a>`dsc_xdhcpserverauthorization`

The DSC xDhcpServerAuthorization resource type.
Automatically generated from version 3.0.0

#### Properties

The following properties are available in the `dsc_xdhcpserverauthorization` type.

##### `dsc_dnsname`

Data type: `Optional[String]`

DHCP Server FQDN

##### `dsc_ensure`

Data type: `Enum['Present', 'Absent']`

Whether the DHCP server should be authorized within Active Directory

##### `dsc_ipaddress`

Data type: `Optional[String]`

DHCP Server IP Address

#### Parameters

The following parameters are available in the `dsc_xdhcpserverauthorization` type.

* [`dsc_issingleinstance`](#dsc_issingleinstance)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_issingleinstance"></a>`dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

Specifies the resource is a single instance, the value must be 'Yes'.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xdhcpserverclass"></a>`dsc_xdhcpserverclass`

The DSC xDhcpServerClass resource type.
Automatically generated from version 3.0.0

#### Properties

The following properties are available in the `dsc_xdhcpserverclass` type.

##### `dsc_description`

Data type: `Optional[String]`

Class Description

#### Parameters

The following parameters are available in the `dsc_xdhcpserverclass` type.

* [`dsc_addressfamily`](#dsc_addressfamily)
* [`dsc_asciidata`](#dsc_asciidata)
* [`dsc_ensure`](#dsc_ensure)
* [`dsc_name`](#dsc_name)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_type`](#dsc_type)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_addressfamily"></a>`dsc_addressfamily`

namevar

Data type: `Enum['IPv4']`

Class address family. Currently needs to be IPv4

##### <a name="dsc_asciidata"></a>`dsc_asciidata`

namevar

Data type: `String`

Class Data, in ASCII format

##### <a name="dsc_ensure"></a>`dsc_ensure`

namevar

Data type: `Enum['Present', 'Absent']`

Whether the DHCP server Class should exist

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Class Name

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_type"></a>`dsc_type`

namevar

Data type: `Enum['Vendor', 'User']`

Class Type, Vendor or User

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xdhcpserveroptiondefinition"></a>`dsc_xdhcpserveroptiondefinition`

The DSC xDhcpServerOptionDefinition resource type.
Automatically generated from version 3.0.0

#### Properties

The following properties are available in the `dsc_xdhcpserveroptiondefinition` type.

##### `dsc_description`

Data type: `Optional[String]`

Option description.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether the DHCP server class should exist.

##### `dsc_multivalued`

Data type: `Optional[Boolean]`

Whether option is multivalued or not.

##### `dsc_name`

Data type: `String`

Option name.

##### `dsc_type`

Data type: `Enum['Byte', 'Word', 'Dword', 'DwordDword', 'IPv4Address', 'String', 'BinaryData', 'EncapsulatedData']`

Option data type.

#### Parameters

The following parameters are available in the `dsc_xdhcpserveroptiondefinition` type.

* [`dsc_addressfamily`](#dsc_addressfamily)
* [`dsc_optionid`](#dsc_optionid)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_vendorclass`](#dsc_vendorclass)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_addressfamily"></a>`dsc_addressfamily`

namevar

Data type: `Enum['IPv4']`

Class address family. Currently needs to be IPv4.

##### <a name="dsc_optionid"></a>`dsc_optionid`

namevar

Data type: `Integer[0, 4294967295]`

Option ID, specify a number between 1 and 255.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_vendorclass"></a>`dsc_vendorclass`

namevar

Data type: `String`

Vendor class. Use an empty string for standard option class.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xdhcpserverreservation"></a>`dsc_xdhcpserverreservation`

The DSC xDhcpServerReservation resource type.
Automatically generated from version 3.0.0

#### Properties

The following properties are available in the `dsc_xdhcpserverreservation` type.

##### `dsc_addressfamily`

Data type: `Optional[Enum['IPv4']]`

Address family type

##### `dsc_clientmacaddress`

Data type: `String`

Client MAC Address to set on the reservation

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether option should be set or removed

##### `dsc_name`

Data type: `Optional[String]`

Reservation name

#### Parameters

The following parameters are available in the `dsc_xdhcpserverreservation` type.

* [`dsc_ipaddress`](#dsc_ipaddress)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_scopeid`](#dsc_scopeid)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_ipaddress"></a>`dsc_ipaddress`

namevar

Data type: `String`

IP address of the reservation for which the properties are modified

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_scopeid"></a>`dsc_scopeid`

namevar

Data type: `String`

ScopeId for which reservations are set

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xdhcpserverscope"></a>`dsc_xdhcpserverscope`

The DSC xDhcpServerScope resource type.
Automatically generated from version 3.0.0

#### Properties

The following properties are available in the `dsc_xdhcpserverscope` type.

##### `dsc_addressfamily`

Data type: `Optional[Enum['IPv4']]`

Address family type

##### `dsc_description`

Data type: `Optional[String]`

Description of DHCP Scope

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether scope should be set or removed

##### `dsc_ipendrange`

Data type: `String`

Ending address to set for this scope

##### `dsc_ipstartrange`

Data type: `String`

Starting address to set for this scope

##### `dsc_leaseduration`

Data type: `Optional[String]`

Time interval for which an IP address should be leased

##### `dsc_name`

Data type: `String`

Name of DHCP Scope

##### `dsc_state`

Data type: `Optional[Enum['Active', 'Inactive']]`

Whether scope should be active or inactive

##### `dsc_subnetmask`

Data type: `String`

Subnet mask for the scope specified in IP address format

#### Parameters

The following parameters are available in the `dsc_xdhcpserverscope` type.

* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_scopeid`](#dsc_scopeid)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_scopeid"></a>`dsc_scopeid`

namevar

Data type: `String`

ScopeId for the given scope

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

